/** @package

        DS_SYNCHRO.PRG
        
        Copyright()  2016
        
        Author: D. SCHUSTER
        Created: S   10.12.16 18:57:22
	Last change: DS 14.12.2016 17:14:16

This utility compares two selected directories.
It is possible to set a filter for type of file.
The directories are displayed, newer files are
marked green, yellow marked files are not present
in the other directory.
Copy and Delete is possible.
	Last change: DS 14.12.2016 17:24:30
*/


#INCLUDE "STD.CH"
#INCLUDE "SET.CH"
#INCLUDE "NATMSG.CH"
#INCLUDE "PROMPT.CH"
#INCLUDE "MEMVAR.CH"
#INCLUDE "COLLAT.CH"
#INCLUDE "DCREG.CH"
#INCLUDE "dcdialog.CH"
#INCLUDE "dcbitmap.CH"
#INCLUDE "directry.ch"
#include "XBP.ch"
#include "gra.ch"
#include "dcmxbutt.ch"
#define MENU_BAR_BGCOLOR       GRA_CLR_BACKGROUND
#define MENU_BAR_FGCOLOR       GRA_CLR_BLACK
#define MENU_SUB_BGCOLOR       GRA_CLR_WHITE
#define MENU_SUB_FGCOLOR       GRA_CLR_BLUE
#define MENU_SUB_BARCOLORFG    GRA_CLR_WHITE
#define MENU_SUB_BARCOLORBG    GRA_CLR_PALEGRAY
#define MENU_SUB_OUTLINECOLOR  GRA_CLR_BLACK
#define MENU_SUB_VERTBARFONT   '12.Arial Bold'
#define MENU_SUB_CHECKFONT     '10.Marlett'
#define MENU_SUB_CHECKCHAR     'b'
#define MENU_BAR_BARFONT       '10.Arial'
#define MENU_SUB_ITEMFONT      '12.Arial'
#define COLOR_RED        GraMakeRGBColor( { 255,   0,   0 } )
#define COLOR_DARKRED    GraMakeRGBColor( { 127,   0,   0 } )
#define COLOR_GREEN      GraMakeRGBColor( {   0, 255,   0 } )
#define COLOR_DARKGREEN  GraMakeRGBColor( {   0, 127,   0 } )
#define COLOR_BLUE       GraMakeRGBColor( {   0,   0, 255 } )
#define COLOR_DARKBLUE   GraMakeRGBColor( {   0,   0, 127 } )
#define COLOR_CYAN       GraMakeRGBColor( {   0, 255, 255 } )
#define COLOR_DARKCYAN   GraMakeRGBColor( {   0, 127, 127 } )
#define COLOR_YELLOW     GraMakeRGBColor( { 255, 255,   0 } )
#define COLOR_BROWN      GraMakeRGBColor( { 127, 127,   0 } )
#define COLOR_PINK       GraMakeRGBColor( { 255,   0, 255 } )
#define COLOR_DARKPINK   GraMakeRGBColor( { 127,   0, 127 } )
#define COLOR_WHITE      GraMakeRGBColor( { 255, 255, 255 } )
#define COLOR_BLACK      GraMakeRGBColor( {   0,   0,   0 } )
#define COLOR_PALEGRAY   GraMakeRGBColor( { 192, 192, 192 } )
#define COLOR_DARKGRAY   GraMakeRGBColor( { 127, 127, 127 } )
#define COLOR_ORANGE     GraMakeRGBColor( { 253, 120,  41 } )
#define COLOR_LTORANGE   GraMakeRGBColor( { 250, 205,   0 } )
#define COLOR_LTBLUE     GraMakeRGBColor( {  30, 187, 255 } )
#define COLOR_LTYELLOW   GraMakeRGBColor( { 128, 128,   0 } )
#define COLOR_DKYELLOW   GraMakeRGBColor( { 212, 212,   0 } )
#define COLOR_DKYELLOW2  GraMakeRGBColor( { 170, 170,   0 } )
#define COLOR_DKBROWN    GraMakeRGBColor( {  72,  72,   0 } )
#define COLOR_SLATEGRAY  GraMakeRGBColor( { 158, 182, 205 } )
#define COLOR_SILVER     GraMakeRGBColor( { 192, 192, 192 } )
#define COLOR_ICEGREEN   GraMakeRGBColor( { 222, 255, 189 } )

MEMVAR cWeiter2

FUNCTION Main()

LOCAL GetList[0], oBrowse, cDir1:=SPACE(70), cDir2:=SPACE(70), n := 1, GetOptions, ;
      aBrowPres, nJJ, cType:="*.*", oType1, oTool
LOCAL aTypeF, nTypeF

aTypeF:={"*.*","*.PRG","*.DBF","*.EXE","*.BAT","*.XPJ","*.NTX","*.BAK"}
nTypeF:=LEN(aTypeF)

SET DATE to SYSTEM
SET DATE FORMAT "dd.mm.yyyy"

aBrowPres := ;
    { { XBP_PP_COL_HA_FGCLR, GRA_CLR_WHITE },            /* Header FG Color  */  ;
      { XBP_PP_COL_HA_BGCLR, GRA_CLR_DARKGRAY },         /* Header BG Color  */  ;
      { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED }, /* Row Sep          */  ;
      { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED }, /* Col Sep          */  ;
      { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },            /* Row FG Color     */  ;
      { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },            /* Row BG Color     */  ;
      { XBP_PP_COL_DA_ROWHEIGHT, 20 },                   /* Row Height       */  ;
      { XBP_PP_COL_HA_HEIGHT, 20 },                      /* Header Height    */  ;
      { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_WHITE },     /* Hilite FG color  */  ;
      { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_BLUE },      /* Hilite BG color  */  ;
      { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },            /* Footer FG Color  */  ;
      { XBP_PP_COL_FA_BGCLR, GRA_CLR_DARKGRAY },         /* Footer BG Color  */  ;
      { XBP_PP_COL_FA_HEIGHT, 10 }                       /* Footer Height    */  ;
    }

 @ 3, 5 DCSAY "Select directory A" SIZE 0 FONT "12. Arial Bold" ;
              COLOR GRA_CLR_BLACK
 @ 3,30 DCGET cDir1 PICTURE "@S70" ;
              POPUP {|c|DC_PopDir(c,,"AB")}
 @ 5, 5 DCSAY "Select directory B" SIZE 0 FONT "12. Arial Bold" ;
              COLOR GRA_CLR_BLUE
 @ 5,30 DCGET cDir2 PICTURE "@S70" ;
              POPUP {|c|DC_PopDir(c,,"AB")}

 @ 7.0,   5 DCSAY "Define Filter " SIZE 0 FONT "12. Arial Bold" ;
            COLOR GRA_CLR_DARKGREEN

 FOR nJJ = 1 TO nTypeF
   @ 7, 20+nJJ*10 DCRADIOBUTTON cType PROMPT aTypeF[nJJ] SIZE 10,1.0 ;
            VALUE aTypeF[nJJ] FONT "9.Arial" COLOR GRA_CLR_BLUE,GRA_CLR_YELLOW
 NEXT

 @ 9, 5 DCTOOLBAR oTool SIZE 26,1.8
          DCADDBUTTON CAPTION "Continue" SIZE 13,1.8 PARENT oTool ;
            ACTION {||Anzeige( cDir1,cDir2,cType ), DC_Getrefresh(GetList)} ;
            FONT "12.Arial Bold" COLOR GRA_CLR_BLACK,GRA_CLR_CYAN ;
            STATIC FOCUSCOLOR GRA_CLR_BLUE,GRA_CLR_YELLOW
          DCADDBUTTON CAPTION "End" SIZE 13,1.8 PARENT oTool ;
            ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_ABORT,Getlist)} ;
            FONT "12.Arial Bold" COLOR GRA_CLR_WHITE,GRA_CLR_RED ;
            STATIC FOCUSCOLOR GRA_CLR_BLUE,GRA_CLR_YELLOW

  DCGETOPTIONS NOCONFIRM ;
               DISABLEDCOLOR GRA_CLR_CYAN ;
               TOOLTIPCOLOR GRA_CLR_BLACK,GRA_CLR_YELLOW ;
               WINDOWHEIGHT 400 ;
               WINDOWWIDTH 950

  DCREAD GUI TITLE "Compare directories" ;
     OPTIONS GetOptions SETAPPWINDOW ;
     HANDLER DlgHandler

RETURN NIL
***
/*
        Name : Display directories
        Does : 
  Parameters : 
     Returns : 
       Notes : 

      Author : ds 
Date Created : 14.12.2016
Time Created : 14:01:21
*/
FUNCTION Anzeige( cDir1,cDir2,cType )
 PUBLIC cWeiter2 := "Y"
 DO WHILE cWeiter2 = "Y"
    Zeige_Dir (cDir1,cDir2,cType )
 ENDDO
 IF cWeiter2 = "N"
   RETURN NIL
 ENDIF
RETURN NIL
***
/*
        Name : 2 selected directories are displayed
        Does : 
  Parameters : aDir1, aDir2
     Returns : 
       Notes : 

      Author : ds 
Date Created : 11.12.2016
Time Created : 10:48:40
*/
FUNCTION Zeige_Dir (cDir1,cDir2,cType )
 LOCAL GetList[0], oBrowse1, oBrowse2, nJJ, aDir1, aDir2 , n1 := 1,  n2 := 1, GetOptions, ;
       aBrowPres, oTool, n, aColors, bColor1, bColor2
 LOCAL oStatTop, oMenuBar, oFileMenu, oEditMenu, oEditMenuSub, ;
       oConfig := DC_XbpPushButtonXPConfig():new(), ;
       aParams, cButtonFont := '12.Arial Bold', bEval, oButton, ;
       oButton1, oButton1a, oButton2, oButton2a
 PUBLIC cWeiter2

 aParams := { MENU_SUB_BGCOLOR, ;
             MENU_SUB_BARCOLORFG, ;
             MENU_SUB_BARCOLORBG, ;
             MENU_SUB_OUTLINECOLOR, ;
             MENU_SUB_VERTBARFONT, ;
             .F., ;
             MENU_SUB_CHECKFONT, ;
             MENU_SUB_CHECKCHAR, ;
             MENU_BAR_FGCOLOR, ;
             MENU_BAR_BGCOLOR, ;
             MENU_SUB_FGCOLOR, ;
             MENU_BAR_BARFONT, ;
             MENU_SUB_ITEMFONT }

 DC_XbpMenuConfig( aParams )
 oConfig:radius := 10
 oConfig:bgColor := GRA_CLR_PALEGRAY

 * Array directory 1
 cDir1:=ALLTRIM(cDir1)+IIF(EMPTY(cDir1),cType,"\"+cType)
 aDir1 := Directory(cDir1)
 FOR n := 1 TO Len(aDir1)
   AAdd(aDir1[n],.f.)  && additional element for hook
   AAdd(aDir1[n],0)    && additional element for color mark
 NEXT
 * ARRAY Directory 2
 cDir2:=ALLTRIM(cDir2)+IIF(EMPTY(cDir2),cType,"\"+cType)
 aDir2 := Directory(cDir2)
 FOR n := 1 TO Len(aDir2)
   AAdd(aDir2[n],.f.)
   AAdd(aDir2[n],0)
 NEXT

 * check date and time, mark arrays
 PRUEFEN(aDir1,aDir2)
 *

 aColors:={{GRA_CLR_BLACK,GRA_CLR_PALEGRAY},;
           {GRA_CLR_WHITE,GRA_CLR_DARKGREEN},;
           {GRA_CLR_BLACK,GRA_CLR_YELLOW}}
 bColor1:={|nSize,nCase|nSize:=DC_GetColArray(12,oBrowse1),;
          nCase:=DC_PickCase(nSize,">=",{100,9,0},{3,2,1}),;
          aColors[nCase]}
 bColor2:={|nSize,nCase|nSize:=DC_GetColArray(12,oBrowse2),;
          nCase:=DC_PickCase(nSize,">=",{100,9,0},{3,2,1}),;
          aColors[nCase]}
 /* Values for nSize (aDirx[y,12]):
     0 : identical files
    10 : newer file
    100: file not found           */

 n1 := 1

 @ 1, 3 DCSAY "Dir A:  "+cDir1 SIZE 0 FONT "16.Arial Bold" COLOR GRA_CLR_BLACK
 @ 1,75 DCSAY "Dir B:  "+cDir2 SIZE 0 FONT "16.Arial Bold" COLOR GRA_CLR_BLUE
 
 @ 3,0 DCBROWSE oBrowse1 DATA aDir1 SIZE 80,18 ;
       PRESENTATION aBrowPres FIT ;
       POINTER n1 ;
       MARK 11 ;
       RESIZE DCGUI_RESIZE_RESIZEONLY

 DCBROWSECOL DATA {|x|x:=DC_GetColArray(11,oBrowse1), ;
          IIF(x,BITMAP_CHECKBOX_CHECKED_S,BITMAP_CHECKBOX_UNCHECKED_S)} ;
       PARENT oBrowse1 HEADER 'Mark' WIDTH 3 ;
       TYPE XBPCOL_TYPE_BITMAP ;
       EVAL {|oB|oB:dataArea:lbClick := {|a,b,o|IIF(oBrowse1:colPos=1,;
            (aDir1[n1,11]:=!aDir1[n1,11],oBrowse1:refreshCurrent()),nil)}}

 DCBROWSECOL ELEMENT 1 PARENT oBrowse1 HEADER 'Name' WIDTH 10 ;
             EVAL {|o|o:ColorBlock:=bColor1}
 DCBROWSECOL ELEMENT 2 PARENT oBrowse1 HEADER 'Size' WIDTH 7
 DCBROWSECOL ELEMENT 3 PARENT oBrowse1 HEADER 'Date' WIDTH 7
 DCBROWSECOL ELEMENT 4 PARENT oBrowse1 HEADER 'Time' WIDTH 7

 n2 := 1

 @ 3,75 DCBROWSE oBrowse2 DATA aDir2 SIZE 80,18 ;
       PRESENTATION aBrowPres FIT ;
       POINTER n2 ;
       MARK 11 ;
       RESIZE DCGUI_RESIZE_RESIZEONLY

 DCBROWSECOL DATA {|x|x:=DC_GetColArray(11,oBrowse2), ;
          IIF(x,BITMAP_CHECKBOX_CHECKED_S,BITMAP_CHECKBOX_UNCHECKED_S)} ;
       PARENT oBrowse2 HEADER 'Mark' WIDTH 3 ;
       TYPE XBPCOL_TYPE_BITMAP ;
       EVAL {|oB|oB:dataArea:lbClick := {|a,b,o|IIF(oBrowse2:colPos=1,;
             (aDir2[n2,11]:=!aDir2[n2,11],oBrowse2:refreshCurrent()),nil)}}

 DCBROWSECOL ELEMENT 1 PARENT oBrowse2 HEADER 'Name' WIDTH 10 ;
             EVAL {|o|o:ColorBlock:=bColor2}
 DCBROWSECOL ELEMENT 2 PARENT oBrowse2 HEADER 'Size' WIDTH 7
 DCBROWSECOL ELEMENT 3 PARENT oBrowse2 HEADER 'Date' WIDTH 7
 DCBROWSECOL ELEMENT 4 PARENT oBrowse2 HEADER 'Time' WIDTH 7

@ 21.5,7 DCPUSHBUTTONXP ;
   CAPTION 'Copy files from ; Dir A to Dir B' ;
   SIZE 25, 3 ;
   ACTION {||Kopiere("AtoB",@aDir1,@aDir2,cDir1,cDir2),;
             DC_ReadGuiEvent(DCGUI_EXIT_OK,Getlist)} ;
   COLOR COLOR_RED, GRA_CLR_WHITE ;
   MOUSECOLOR nil, COLOR_ORANGE ;
   CLICKCOLOR nil, COLOR_PINK ;
   BITMAP BITMAP_NEXT_M OFFSET 15 ;
   FONT '12.Arial Bold' ;
   RADIUS 20 ;
   OBJECT oButton1 ;
   SHADOW 6

@ 21.5,39 DCPUSHBUTTONXP ;
   CAPTION 'Delete files;in Dir A' ;
   SIZE 20, 3 ;
   ACTION {||Loesche("DirA",@aDir1,@aDir2,cDir1,cDir2),;
             DC_ReadGuiEvent(DCGUI_EXIT_OK,Getlist)} ;
   COLOR COLOR_WHITE, GRA_CLR_RED ;
   MOUSECOLOR nil, COLOR_PINK ;
   CLICKCOLOR nil, COLOR_DKYELLOW ;
   FONT '12.Arial Bold' ;
   RADIUS 20 ;
   OBJECT oButton1a ;
   SHADOW 6


@ 21.5,82 DCPUSHBUTTONXP ;
   CAPTION 'Copy files from ; Dir B to Dir A' ;
   SIZE 25, 3 ;
   ACTION {||Kopiere("BtoA",@aDir1,@aDir2,cDir1,cDir2),;
             DC_ReadGuiEvent(DCGUI_EXIT_OK,Getlist)} ;
   COLOR COLOR_DARKGREEN, COLOR_LTBLUE ;
   MOUSECOLOR nil, COLOR_CYAN ;
   CLICKCOLOR nil, COLOR_PINK ;
   BITMAP BITMAP_PREVIOUS_M OFFSET 15 ;
   FONT '12.Arial Bold' ;
   RADIUS 20 ;
   OBJECT oButton2 ;
   SHADOW 6

@ 21.5,114 DCPUSHBUTTONXP ;
   CAPTION 'Delete files;in Dir B' ;
   SIZE 20, 3 ;
   ACTION {||Loesche("DirB",@aDir1,@aDir2,cDir1,cDir2),;
             DC_ReadGuiEvent(DCGUI_EXIT_OK,Getlist)} ;
   COLOR COLOR_WHITE, GRA_CLR_RED ;
   MOUSECOLOR nil, COLOR_PINK ;
   CLICKCOLOR nil, COLOR_DKYELLOW ;
   FONT '12.Arial Bold' ;
   RADIUS 20 ;
   OBJECT oButton2a ;
   SHADOW 6


 @ 25, 5 DCSAY "Green marked files are newer date or time." ;
               SIZE 0 FONT "12.Arial Bold" COLOR GRA_CLR_BLUE
 @ 26, 5 DCSAY "Yellow marked files are not present in the respective other directory." ;
               SIZE 0 FONT "12.Arial Bold" COLOR GRA_CLR_BLUE

 DCSTATUSBAR oStatTop HEIGHT 29 ALIGN DCGUI_ALIGN_TOP
 @ 0,0 DCTOOLBAR oMenuBar SIZE 1000,29 PIXEL PARENT oStatTop BUTTONSIZE 80,29 ;
      COLOR nil, GRA_CLR_PALEGRAY FONT '14.Arial Bold'

 DCADDBUTTONXP CAPTION ' End ' PARENT oMenuBar CONFIG oConfig ;
    COLOR GRA_CLR_BLACK,GRA_CLR_YELLOW MOUSECOLOR nil,GRA_CLR_WHITE ;
    ACTION {||cWeiter2:="N",DC_ReadGuiEvent(DCGUI_EXIT_OK,Getlist) }

 DCGETOPTIONS RESIZE

 DCREAD GUI FIT MODAL ;
        OPTIONS GetOptions ;
        TITLE 'Mark files to be copied'

RETURN NIL
***

* ---------

PROC appsys ; RETURN

* ---------

STATIC FUNCTION DlgHandler ( nEvent, mp1, mp2, oXbp, ;
                oDialog, GetList, aApp )
RETURN DCGUI_NONE
***
/*
        Name : check date and time, mark arrays
        Does : 
  Parameters : arrays to be compared
     Returns : 
       Notes : 

      Author : ds 
Date Created : 11.12.2016
Time Created : 16:13:01
*/
FUNCTION PRUEFEN(aDir1,aDir2)
 LOCAL nJJ, nLL1, cName, nPos,dDatum, cZeit1, nZeit1
 LOCAL nLL2, cZeit2, nZeit2

 * Loop in Dir1
 nLL1:=LEN(aDir1)
 FOR nJJ = 1 TO nLL1
   cName  :=UPPER(aDir1[nJJ,1])
   dDatum :=aDir1[nJJ,3]
   cZeit1  :=aDir1[nJJ,4]
   nZeit1  :=VAL(SUBSTR(cZeit1,1,2))*3600+VAL(SUBSTR(cZeit1,4,2))*60+;
            VAL(SUBSTR(cZeit1,7,2))
   nPos   :=ASCAN(aDir2,{|a|UPPER(a[1])=cName},1 )
   IF nPos > 0
     cZeit2  :=aDir2[nPos,4]
     nZeit2  :=VAL(SUBSTR(cZeit2,1,2))*3600+VAL(SUBSTR(cZeit2,4,2))*60+;
                   VAL(SUBSTR(cZeit2,7,2))
     IF aDir2[nPos,3] = dDatum .AND. nZeit2 = nZeit1
     ELSE
       IF aDir2[nPos,3] = dDatum
         IF nZeit2 > nZeit1
           aDir2[nPos,12]:=10
         ELSEIF nZeit2 < nZeit1
           aDir1[nJJ,12]:=10
         ENDIF

       ELSEIF aDir2[nPos,3] > dDatum
         aDir2[nPos,12]:=10
       ELSE
         aDir1[nJJ,12]:=10
       ENDIF
     ENDIF
   ELSE
     aDir1[nJJ,12]:=110
   ENDIF
 NEXT
 *
 * Check Dir2 for files not present in Dir1
 nPos:=0
 nLL2:=LEN(aDir2)
 FOR nJJ = 1 TO nLL2
   cName  :=UPPER(aDir2[nJJ,1])
   nPos   :=ASCAN(aDir1,{|a|UPPER(a[1])=cName},1 )
   IF nPos = 0
     aDir2[nJJ,12]:=110
   ENDIF
 NEXT

RETURN NIL
***
/*
        Name : Copy files from one to the other directory
        Does : 
  Parameters : cWas = "AtoB" or "BtoA"
     Returns : 
       Notes : 

      Author : ds 
Date Created : 12.12.2016
Time Created : 10:21:05
*/
FUNCTION Kopiere(cWas,aDir1,aDir2,cDir1,cDir2)
 LOCAL nJJ, nLL, cPath1, cPath2, nPos, cFile1, cFile2

 * determine path name of Dir1
 nPos:=RAT("\",cDir1)
 IF nPos > 0
   cPath1:=LEFT(cDir1,nPos)
 ELSE
   MsgBox("Problem with Path name A","Error")
   RETURN NIL
 ENDIF
 * determine path name of Dir2
 nPos:=RAT("\",cDir2)
 IF nPos > 0
   cPath2:=LEFT(cDir2,nPos)
 ELSE
   MsgBox("Problem with Path name B","Error")
   RETURN NIL
 ENDIF
 * copy from Dir1 to Dir2
 IF cWas = "AtoB"
   nLL:=LEN(aDir1)
   FOR nJJ = 1 TO nLL
     aDir1[nJJ,12] := 0
     IF aDir1[nJJ,11] = .T.
       cFile1:=cPath1+aDir1[nJJ,1]
       cFile2:=cPath2+aDir1[nJJ,1]
       COPY FILE (cFile1) TO (cFile2)
       aDir1[nJJ,11] := .F.
     ENDIF
   NEXT
 ENDIF
 * copy from Dir2 to Dir1
 IF cWas = "BtoA"
   nLL:=LEN(aDir2)
   FOR nJJ = 1 TO nLL
     aDir2[nJJ,12] := 0
     IF aDir2[nJJ,11] = .T.
       cFile1:=cPath2+aDir2[nJJ,1]
       cFile2:=cPath1+aDir2[nJJ,1]
       COPY FILE (cFile1) TO (cFile2)
       aDir2[nJJ,11] := .F.
     ENDIF
   NEXT
 ENDIF

 * Update arrays
 PRUEFEN(aDir1,aDir2)

RETURN NIL
***
/*
        Name : Delete Files
        Does : 
  Parameters : 
     Returns : 
       Notes : 

      Author : ds 
Date Created : 12.12.2016
Time Created : 16:32:21
*/
FUNCTION Loesche(cWas,aDir1,aDir2,cDir1,cDir2)
 LOCAL nJJ, nLL, cPath1, cPath2, nPos, cFile1, cFile2
 LOCAL nDel1:=0, nDel2:=0, aButtons:={"Yes","No"}, nChoice

 * determine path name of Dir1
 nPos:=RAT("\",cDir1)
 IF nPos > 0
   cPath1:=LEFT(cDir1,nPos)
 ELSE
   MsgBox("Problem with Path name A","Error")
   RETURN NIL
 ENDIF
 * determine path name of Dir2
 nPos:=RAT("\",cDir2)
 IF nPos > 0
   cPath2:=LEFT(cDir2,nPos)
 ELSE
   MsgBox("Problem with Path name B","Error")
   RETURN NIL
 ENDIF

 IF cWas = "DirA"
   * Number of files to delete in Dir1
   AEVAL(aDir1,{|x,i|nDel1:=nDel1+IIF(aDir1[i,11] = .T.,1,0) }  )
   nChoice := DC_ALERT("You want to delete these "+STR(nDel1,3)+" files?" ,;
              aButtons,"GRA_CLR_RED,GRA_CLR_BLACK,GRA_CLR_BLUE,GRA_CLR_PINK" ,,,,,,;
              {"10.Arial","12.Arial Bold"} )
   IF nChoice = 1
   ELSE
     MsgBox("No file deleted","Info")
     RETURN NIL
   ENDIF
   * Delete files in Dir1
   nLL:=LEN(aDir1)
   FOR nJJ = 1 TO nLL
     aDir1[nJJ,12] := 0
     IF aDir1[nJJ,11] = .T.
       cFile1:=cPath1+aDir1[nJJ,1]
       ERASE (cFile1)
       aDir1[nJJ,12] = 99
     ENDIF
   NEXT
   * Resize array Dir1
   FOR nJJ = nLL TO 1 STEP -1
     IF aDir1[nJJ,12] = 99
       aDEL(aDir1,nJJ)
       aSIZE(aDir1,LEN(aDir1)-1)
     ENDIF
   NEXT
 ENDIF

 IF cWas = "DirB"
   * Number of files to delete in Dir2
   AEVAL(aDir2,{|x,i|nDel2:=nDel2+IIF(aDir2[i,11] = .T.,1,0) }  )
   nChoice := DC_ALERT("You want to delete these "+STR(nDel2,3)+" files?" ,;
              aButtons,,,,,,,{"10.Arial","12.Arial Bold"} )
   IF nChoice = 1
   ELSE
     MsgBox("No file deleted","Info")
     RETURN NIL
   ENDIF
   * Delete files in Dir2
   nLL:=LEN(aDir2)
   FOR nJJ = 1 TO nLL
     aDir2[nJJ,12] := 0
     IF aDir2[nJJ,11] = .T.
       cFile1:=cPath2+aDir2[nJJ,1]
       ERASE (cFile1)
       aDir2[nJJ,12] = 99
     ENDIF
   NEXT
   * Resize array Dir2
   FOR nJJ = nLL TO 1 STEP -1
     IF aDir2[nJJ,12] = 99
       aDEL(aDir2,nJJ)
       aSIZE(aDir2,LEN(aDir2)-1)
     ENDIF
   NEXT
 ENDIF

RETURN NIL
***
